#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <string.h>
//Prototipos das funcoes
int  det(int**,int);
int**matrizMenor(int**,int**,int,int);
int**alocarMQ(int);
int**freeMQ(int**,int);
void printMQ(int**,int);

typedef struct no //Lista encadeada que guarda informaes do caminho
{
    int determinante;
    int c1;
    int c2;
    int c3;
    int c4;
    int tamanho;
    int direcao;
    struct no* prox;
} Lista;

//Retorna o determinante da matriz m de ordem n por Laplace
int det(int **m, int n)
{
    //Caso fundamental
    if (n == 1)
        return **m;

    //Criando a matriz do cofator
    int c, cof, d=0, **m2 = alocarMQ(n-1);

    //Para cada coluna
    for (c=0; c<n; c++)
    {
        //Calculando o cofator
        cof = (c%2?-1:1) * det(matrizMenor(m, m2, c, n), n-1);
        //Somando a parcela ao determinante final
        d += m[0][c]*cof;
    }

    //Liberando o espao alocado da matriz do cofator
    freeMQ(m2, n-1);

    //Retornando o determinante
    return d;
}

//Retira a primeira linha a coluna c de m e armazena em m2. n  a ordem de m
int **matrizMenor(int **m, int **m2, int c, int n)
{
    int i, j, **p=m2, *p2;
    for (i = 1; i < n; i++)
    {
        p2 = *p++;
        for (j = 0; j < n; j++)
            if (j==c) continue;
            else *p2++ = m[i][j];
    }
    return m2;
}

//Aloca espao para uma matriz quadrada
int **alocarMQ(int n)
{
    int **m, i;
    m = (int**)calloc(n, sizeof(int*));
    if (m == NULL) exit(1);
    for (i=0; i<n; i++)
    {
        *(m+i) = (int*)calloc(n, sizeof(int));
        if (*(m+i) == NULL) exit(1);
    }
    return m;
}

//Desaloca espao de uma matriz quadrada
int **freeMQ(int **m, int n)
{
    int i;
    if (m == NULL) return NULL;
    for (i=0; i<n; i++) free(m[i]);
    free(m);
    return NULL;
}

//Insere um elemento na lista encadeada
Lista* inserir(Lista* inicio,int determinante, int c1, int c2, int c3, int c4, int tamanho, int sentido)
{
    Lista* novo = (Lista*) malloc(sizeof(Lista));
    Lista* p = inicio;
    novo->determinante = determinante;
    novo->c1 = c1;
    novo->c2 = c2;
    novo->c3 = c3;
    novo->c4 = c4;
    novo->tamanho = tamanho;
    novo->direcao = sentido;
    novo->prox = NULL ;
    if (inicio == NULL)
    {
        p = novo;
        inicio = p;
    }
    else
    {
        while (p->prox != NULL)
        {
            p = p->prox;
        }
        p->prox = novo;
    }
    return inicio ;
}

//decide o melhor caminho, a partir do menor determinante de cada rota.
Lista* melhor_caminho (FILE* mapa, Lista* inicio)
{
    int **matriz, caminhos, ordem, determinante=9999, tamanho=0, sentido=0;
    int  i,j,k, rotas, cont = 0;
    int c1=0, c2=0, c3=0, c4=0;
    char temp[5];

    fscanf (mapa, "%s", temp);
    caminhos = atoi (temp);
    fgetc(mapa);
    for (k=0;k<caminhos; k++)
    {
        fscanf (mapa, "%s", temp);
        ordem = atoi (temp);
        fgetc (mapa);

        matriz = alocarMQ (ordem);
        for (rotas=0; rotas<5;rotas++)
        {
            for (i=0;i<ordem;i++)
            {
                for (j=0;j<ordem;j++)
                {
                    fscanf (mapa, "%s", temp);
                    matriz[i][j] = atoi (temp);
                    fgetc (mapa);
                    switch (cont)
                    {
                    case 0:
                        c1 = matriz[i][j];
                        break;
                    case 1:
                        c2 = matriz[i][j];
                        break;
                    case 2:
                        c3 = matriz[i][j];
                        break;
                    case 3:
                        c4 = matriz[i][j];
                        break;
                    default:
                        break;
                    }
                    cont ++;
                }
            }

            if (det (matriz, ordem)<determinante)
            {
                determinante = det (matriz, ordem);
                fscanf (mapa, "%s", temp);
                tamanho = atoi (temp);
                sentido = rotas;
            }
            else
            {
                fscanf (mapa, "%s", temp);
            }
            fgetc(mapa);
            cont = 0;
        }
        inicio = inserir (inicio, determinante, c1, c2, c3, c4, tamanho, sentido);
        determinante = 9999;

    }
    return inicio;
}
