#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#define PERMISSIVIDADE (8*pow((double)10,(double)-12))

typedef struct dados //Estrutura que guarda dados
{
    double ddp;
    double corrente;
    double pot_dissipada;
    double gasto;
    float velocidade;
    int tempo;
    int distancia;
}Dados;

void calculos (FILE* config, Dados* robo) //Calculando os dados e preenchendo a estrutura
{

    char tipo, associacao;
    int i, n, tempo, gasto_motor, gasto_leds, gasto_perdas;
    double custo_motor, custo_leds, custo_perdas, kwatts, custo_total;
    double resist_motor, resist_leds, resist_fios, resist_eq;
    double r1=0, r2=0, altura=0, distancia=0, *capacitor, capacitancia=0, area=0;
    double carga, ddp, corrente, pot_dissipada;
    char temp[5];

    fscanf (config,"%s", temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    tempo = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    gasto_motor = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    gasto_leds = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    gasto_perdas = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    kwatts = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    custo_motor = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    custo_leds = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    custo_perdas = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    resist_motor = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    resist_leds = atoi (temp);
    fgetc(config);
    fscanf (config,"%s", temp);
    resist_fios = atoi (temp);
    fgetc(config);
    tipo = fgetc(config);
    fgetc(config);
    fscanf (config,"%s", temp);
    n = atoi(temp);
    capacitor = (double*) malloc (n * sizeof(double));
    fgetc(config);
    fscanf (config,"%s", temp);
    carga = atoi(temp);
    fgetc(config);
    associacao = fgetc(config);

    if (tipo == 'E')
    {
        fscanf (config,"%s", temp);
        r1= atoi(temp);
        fgetc(config);
        fscanf (config,"%s", temp);
        r2= atoi(temp);
        fgetc(config);

        for (i=0;i<n;i++)
        {
            capacitor[i] += 4 * M_PI * PERMISSIVIDADE * ((r1*r2)/(r2-r1));
        }
    }
    else if (tipo == 'C')
    {
        fscanf (config,"%s", temp);
        altura= atoi(temp);
        fgetc(config);
        fscanf (config,"%s", temp);
        r1= atoi(temp);
        fgetc(config);
        fscanf (config,"%s", temp);
        r2= atoi(temp);
        fgetc(config);


        for (i=0;i<n;i++)
        {
            capacitancia += 2 * M_PI * PERMISSIVIDADE * altura * log(r2/r1);
        }
    }

    else if (tipo == 'P')
    {
        fscanf (config,"%s", temp);
        area= atoi(temp);
        fgetc(config);
        fscanf (config,"%s", temp);
        distancia= atoi(temp);
        fgetc(config);

        for (i=0; i<n; i++)
        {
            capacitancia += (PERMISSIVIDADE * area)/distancia;
        }
    }

    if (associacao == 'S')
    {
        for (i=0;i<n;i++)
        {
            capacitancia += pow (capacitor[i], -1);
        }

        capacitancia = pow (capacitancia, -1);
        resist_eq = resist_fios + resist_leds + resist_motor;
    }
    else if (associacao == 'P')
    {
        for (i=0;i<n;i++)
        {
            capacitancia += capacitor[i];
        }
        resist_eq = pow(((pow(resist_fios, -1))+(pow(resist_leds,-1))+(pow(resist_motor,-1))), -1);
    }

    ddp = carga/resist_eq;
    corrente = ddp/resist_eq;
    pot_dissipada = pow (ddp, 2)/resist_eq;
    custo_total = (custo_leds+custo_motor+custo_perdas)*kwatts;

    robo->ddp = ddp;
    robo->corrente = corrente;
    robo->pot_dissipada = pot_dissipada;
    robo->gasto= custo_total;
}

void velocidade (FILE* config, Lista* inicio, Dados* robo) //Calcula velocidade
{
    char temp[10];
    int distancia=0;
    Lista* p ;
    Lista* auxiliar = inicio;
    fscanf (config, "%s", temp);
    fgetc(config);
    fscanf (config, "%s", temp);
    robo->tempo = atoi(temp);
    for(p = inicio; auxiliar != NULL ; p = p->prox )
    {
        distancia += p->tamanho;
        auxiliar = auxiliar->prox;
    }
    robo->distancia = distancia;
    robo->velocidade = (float)(robo->distancia)/(float)(robo->tempo);
}


